﻿using PIHelperSh.PdfCreator.Enums;

namespace Cop.Borovkov.Var3.Models
{
    /// <summary>
    /// Параметры для создания линейной диаграммы
    /// </summary>
    public record PdfHistigramInfo
    {
        /// <summary>
        /// Имя файла (включая путь до файла)
        /// </summary>
        public string FilePath { get; init; } = @"C:\pdfTable.pdf";

        /// <summary>
        /// Заголовок документа
        /// </summary>
        public string DocumentTitle { get; init; } = "Гистограмма";

        /// <summary>
        /// Заголовок диаграммы
        /// </summary>
        public string HistogramTitle { get; init; } = "Гистограмма";

        /// <summary>
        /// Расположение легенды
        /// </summary>
        public PdfLegendPosition LegendPosition { get; init; } = PdfLegendPosition.Bottom;

        /// <summary>
        /// Значения
        /// </summary>
        public required IEnumerable<PdfHistogramLineInfo> Values { get; init; }
}
}
