﻿namespace Cop.Borovkov.Var3.Models
{
    /// <summary>
    /// Параметры для создания таблицы в пдф с группировкой по 1 столбцу
    /// </summary>
    public class PdfTableWithGroupingInfo<TType> where TType : class
    {
        /// <summary>
        /// имя файла (включая путь до файла)
        /// </summary>
        public string FilePath { get; init; } = @"C:\pdfTable.pdf";

        /// <summary>
        /// название документа(заголовок в документе)
        /// </summary>
        public string Title { get; init; } = "Таблица";

        /// <summary>
        /// Высота заголовков
        /// </summary>
        public float HeaderHeight { get; init; } = 0.5f;

        /// <summary>
        /// Параметры столбцов
        /// </summary>
        public IEnumerable<ColumnInfo> Columns { get; init; } = [];

        /// <summary>
        /// Список таблиц
        /// </summary>
        public IEnumerable<RowInfo<TType>> Rows { get; init; } = [];
    }
}
