﻿using DocumentFormat.OpenXml.Office2010.Excel;
using Lab3.Database.Extensions;
using Lab3.Database.Repository.Interfaces;
using Lab3.Forms;
using Lab3.MappingProfiles;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;

namespace Lab3.Extensions
{
    public static class DIExtension
    {
        public static IServiceCollection ConfigureDAL(
            this IServiceCollection services, 
            IConfiguration configuration)
        {
            services.AddDatabase(configuration);
            services.AddDbMapping();
            services.AddRepositories();

            return services;
        }

        public static IServiceCollection AddLab3Forms(
            this IServiceCollection services)
        {
            services.AddScoped<MainForm>();
            services.AddScoped<CatalogForm>();

            services.AddScoped<Func<Guid?, CreateForm>>(sp => (id 
                => new CreateForm(
                    sp.GetRequiredService<IStudentRepository>(),
                    sp.GetRequiredService<IEducationFormRepository>(),
                    id
                )));

            return services;
        }

        public static IServiceCollection AddMapping(
            this IServiceCollection services)
        {
            services.AddAutoMapper(typeof(StudentViewMappingProfile));

            return services;
        }
    }
}
